#|
Copyright (c) 2012 Prévot Nicolas
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
|#


; ce fichier contient tous les déclencheurs de base: opérateurs...



;(setf {two-points (make-_fg :prio prio-pt-virgule :fonc nil))


(setf operator
	(lambda (gauche f de)
		(if (null f) 
			(error "syntax error: nothing after operator ~a" (decl-donnee de))
			(progn
				(multiple-value-setq (gr fr) (eval2 f (decl-prio de)))
				(values (list (decl-donnee de) gauche gr) fr))))); donnee est l'opérateur



(defun add-operator (op op-lisp prio); pour ajouter un opérateur binaire qui ne fait qu'appeller un opérateur du lisp
	(set op 
		(make-decl :prio prio :fonc operator :donnee op-lisp)))

(defun fonc-unary-prec (gauche f de);opéraeurs unaires portant sur l'élément précédent
  (values 
    (funcall (decl-donnee de) gauche)
    f))

(defmacro add-unary-prec (symb prio code); macro pour les entrer
  `(setf ,symb
    (make-decl
      :prio ,prio
      :fonc #'fonc-unary-prec
      :donnee ,code)))

(add-unary-prec |++| |prio++|
                (lambda (x)
                  `(incf ,x)))

(add-unary-prec |--| |prio++|
                (lambda (x)
                  `(decf ,x)))

(entre-fonc-g2 |;| |prio;| 
	(delimiteur |prio;|
		((if (not (null gauche-r))
			(ajoute res gauche-r)))
			'|;|
		(if (null res)
			gauche
			`(progn ,gauche ,@res)))) ; le ; ne renvoit pas de code: seul le gauche est non nul


(setf |list|; pour une liste
	(make-decl :prio |prio_fonctions| :fonc 
		(lambda (gauche f de)
			(let ((res (delimit (first f) |prio,| '|,| #'eval2)))
				(values (cons 'list res) (rest f))))))

(setf |'|; pour les quote
	(make-decl :prio number-min :fonc 
		(lambda (gauche f de)
			(if (not (null gauche)) (error "deux formes de suite"))
			(if (null f) (error "attendait quelque chose après '"))
			(values (list 'quote (first f)) (rest f)))))


(setf |$| ; pour les valeurs multiples
	(make-decl :prio |prio$| :fonc
		(lambda (gauche f de)
			(let ((gr f))
				(multiple-value-setq (renv f) (delimit f |prio$| '|$| #'eval2))
				(values
					(cons 'values 
						(cons 
							gauche 
							renv))
					f)))))


(defun fonc-struct (gauche f decl)
	(if (not (null gauche)) (error "deux formes de suite"))
	(let ((res (list (decl-donnee decl))) (l (first f))(temp)); dans l se trouvent les x-> 4 , y-> 5
		(loop 
			(push (read-from-string (concatenate 'string ":" "|" (string (first l)) "|")) res) ;on met le nom de la variable. On ne peut pas utiliser add-to-symb car ici, intern ne marche pas
			(setf l (rest l))
			(wait-for l '-> "attendait un ->")
			(multiple-value-setq (temp l) 
				(eval2 l |prio,|))
			(push temp res)
			(if (null l)
				(return))
			(wait-for l '|,| "attendait un ,"))
	(values (reverse res) (rest f)))); on retourne res pour tout remettre dans l'ordre


(defun entre-struct (symb) ;entre symb comme une structure. (on ne met pas encore les champs)
	(set symb
		(make-decl
			:prio |prio_structures|
			:donnee (add-to-symb "MAKE-" symb) ;non d
			:fonc #'fonc-struct)))


(defmacro entre-symbole-inutile (s message)
	`(setf ,s 
		(make-decl 
			:fonc
			(lambda (gauche f de)
				(error ,message))
			:prio	
			number-max)))

(entre-symbole-inutile |->| "-> ne peut pas être exécuté")

(entre-fonc-g2 |,| |prio,| nil)


#|(entre-fonc-g2 two-points prio-virgule
	(delimiteur prio-after-pt-virgule
	((ajoute res gauche-r)) 
	'comma 
	(values `(list ,gauche ,@res) f))) |#



#|
(entre-fonc-g2 |loop| number-min
	(get-next gauche-r f 
		(return-from 'fonc-g
			(values `(loop ,gauche-r) (cons '|;| f)))));on doit ajouter un ; pour le cas ou le ; marquerait la fin de l'instruction de la ligne, pas du if
|#


(entre-fonc-g2 |loop| number-min
	(construct-res f
		(add-res 'loop)
		(append-next)
		(add-start-form '|;|)))

(entre-fonc-g2 |lambda| number-min
	(construct-res f
		(add-res 'lambda)
		(get-without-eval)
		(append-next)))

(defun separe-un (del f); f est censée être composée d'un élément puis del puis un élément puis del ... renvoit la liste des éléments sans ,
  (if (null f) nil
    (let ((a (first f)))
      (cond
        ((eq a del) (error "too much ~a" del))
        ((null (rest f)) (list a))
        (t (let ((r (rest f)))
         (if (eq (first r) del)
           (cons a (separe-un del (rest r)))
           (error "not enough ~a" del))))))))
        


(entre-fonc-g2 |defun| number-min
	(construct-res f
		(add-res 'defun)
		(get-without-eval)
    (let ((args))
      (get-without-eval args)
      (add-res (separe-un '|,| (first args))))
		(append-next)))


(defun fonc-pour-macro (gauche f decl) ; sert à l'appel d'une "macro"
  (let ((liste-args (separe (first f) '|,|)))
  (values nil (append (apply (decl-donnee decl) liste-args) (rest f)))))

(entre-fonc-g2 |defmacro2| number-min
	(construct-res f
    (let ((nom-fonction) (arguments) (code))
      (get-without-eval nom-fonction)
      (get-without-eval arguments)
      (append-next code)
      (setf arguments (separe-un '|,| (first arguments)))
      (set (first nom-fonction) (make-decl 
        :prio number-min
        :fonc #'fonc-pour-macro
        :donnee
        (eval `(lambda ,arguments ,@code))))
      (values nil f))))







(entre-fonc-g2 |print| number-min
	(let ((res nil) (gauche-r))
		(multiple-value-setq (gauche-r f) (eval2 f |prio,|))
		(values `(print ,gauche-r) f)))  



(entre-var |nil| nil)

(entre-var |return| '(return))


(entre-fonc-g2 |eval_now| number-min
	(let ((res nil))
	(push 'progn res)
	(append-next res)
	(eval res)
	(values nil f)))

(entre-fonc-g2 |if| number-min
	(construct-res f
		(add-res 'if)
		(append-next)
		(append-next)
		(avance-si f '|;|)
		(when (eq (first f) '|else|)
			(avance-in-form)
			(append-next))
		(add-start-form '|;|)))

(entre-fonc-g2 |entre_decl| number-min ; macro qui sert à entrer des déclencheurs au niveau 2
	(construct-res f
		(let ((res nil))
			(add-res 'entre-fonc-g2 res)
			(get-without-eval res); on récupère le nom	
			(get-without-eval res); on récupère la priorité
			(append-next res) ; on récupère le code
			(eval res)))); on exécute

(entre-fonc-g2 |$#| number-min ;pour entrer une expression lisp
	(values (cherche-eval2 (first f)) (rest f)))

(defun cherche-eval2 (f) ;si ce n'est pas une liste: renvoit nil. Sinon,  si elle trouve un #$ dedans, elle évalue avec eval2 l'expression qui suit
	(cond
		((or (null f) (not (listp f)))
			f)
		((eq (first f) '|#$|) 
		 (let (( u (nth 1 f)))
			 (let ((temp 
				(if (listp u)
					(eval2 u number-max)
					u)))
			 		(cons temp (cherche-eval2 (rest (rest f)))))))
		(t 
		 (cons 
			 (cherche-eval2 (first f)) 
			 (cherche-eval2 (rest f))))))


;(entre-fonc-g2 |def_decl| number-min


(defun symb-prio (op) ; renvoit |prio,| pour ,
	(read-from-string (concatenate 'string "|prio|" (string op))))

(defun add-all-operators (l) ; l est constituée de: soit les opérateurs 2 (mêmes que les lisp), soit les opérateurs 2 puis les lisp. Les priorités sont écrites dans priorités
	(loop
		for i in l
		for op = nil
		for oplisp = nil
		do
		(if (atom i)
			(progn
				(setf op i)  
				(setf oplisp i))  
			(progn
				(setf op (first i))
				(setf oplisp (nth 1 i))))
		(add-operator op oplisp (symbol-value (symb-prio op)))))

(add-all-operators '(* + - < (= setf) (== eq)))

(entre-var |rest_form| 'ftruc)

(defun |def_decl| (fonc prio &optional donnee)
	(make-decl :fonc fonc :donnee donnee :prio prio))

#|
(defun cherche-tilde (symb); renvoit le nombre de ~ au début de symb puis s'il y a un @ ensuite 
  (let  ((str (string symb)) (nb 0)) 
    (loop
      :while (eq (aref str nb) #\~)
      :do
      (incf nb)); alors: nb vaut le nombre de ~
    (if (eq (aref str nb)#\@)
      (values nb t)
      (values nb nil))))

(defun place-unquote (ntilde est_a f); renvoit des unquote
  (cond
    ((and (eq 0 ntilde) est_a) 
     `(SYSTEM::SPLICE ,(eval2 f number-max) ))
    ((eq 0 ntilde)
     (eval2 f number-max))
    (t `(SYSTEM::UNQUOTE ,(place-unquote (- ntilde 1 )est_a f)))))

(defun pour-backquote (f); va remplacer les symboles ~ par ce qu'il faut
  (let ((a (first f) (ntilde ) (est_a))) 
    (cond 
      ((listp a)
       (cons (pour-backquote (first f)) (pour-backquote (rest f))))
      ((symbolp a) 
       (multiple-value-setq (ntilde est_a) (cherche-tilde a))
       (if (not (eq 0 ntilde)))))))
|#
