#|
Copyright (c) 2012 Prévot Nicolas
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
|#
#|(defun separe (st del) ; renvoit la chaine avant la première occurence de del et celle après
	(do
		((i 0 (+ 1 i)))
		((eq i (length st)) (values st ""))
		(if (eq (aref st i) del) (return (values (substring st 0 i) (substring st (+ 1 i))))))) |#

(defmacro ajoute (l1 a) ;ajoute a à la fin de la liste l1
	`(setf ,l1 (append ,l1 (list ,a))))

(defmacro ajoute-string (st a) ;ajoute a au string st 
	`(setf ,st (concatenate 'string ,st (string ,a))))

(defmacro avance (l)
	`(setf ,l (rest ,l)))

(defmacro consn (&rest l) ;permet de faire un cons avec plus d'un élément
	(if (eq (length l) 1)
		(first l)
		`(cons ,(first l) ,(cons 'consn (rest l)))))

(defun my-map (op l) ;applique op au dernier, puis avec le précédent...
	(cond ((null l) nil)
		((null (rest l)) (first l))
		(t (funcall op (first l) (my-map op(rest l) )))))


(defun all-same-length (l) ;renvoit si toutes les listes de l ont la même longueur
	(let ((taille (length (first l))))
		(my-map 
			(lambda (a b) (and a b))
			(mapcar
				(lambda (a) (eq (length a) taille))
				(rest l)))))


(defun see-all (message) ;affiche message et permet à l'utilisateur d'afficher les valeurs des variables jusqu'à ce qu'il entre stop
  (let ((reponse)) 
    (print message)
    (loop
      (setf reponse(read)) 
      (if (eq reponse 'stop)
        (return))
      (print (eval reponse)))))
  

