#|
Copyright (c) 2012 Prévot Nicolas
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
|#

; explications:
; d'abord, il y a les stre. Ils correspondent soit à un string, soit à un flux réel.
; Ils ont aussi les fonctions go-end-line et go-end-comment
;
; ensuite: les entry: ils gèrent les tabulations pour donner des ( )
; ils on renv-sl pour dire s'il renvoit un / mais en fait, c'est utilisé par entry2
;
; les entry2 gèrent aussi les commentaires 


(defun peek-stre2 (stre2) ;first stre2: vaut 0 si c'est un stream normal, 1 si c'est un string. 1: le stream ou le string. 2: position dans la chaine si c'est un stream, numéro de la ligne dans le fichier sinon . 
	(if (eq (first stre2) 0)
		(peek-char nil (nth 1 stre2) nil nil)
		(if (< (nth 2 stre2) (length (nth 1 stre2)))
			(aref (nth 1 stre2) (nth 2 stre2))
			nil)))

(defun get-stre2 (stre2)
	(if (eq (first stre2) 0) ;stream
		(let ((res (read-char (nth 1 stre2) nil nil)))
			(if (eq res #\Newline )
				(incf (nth 2 stre2)))
				res)
		(progn ;string
			(let ((pos (nth 2 stre2)))
				(if (< pos (length (nth 1 stre2)))
					(progn
						(setf (nth 2 stre2) (+ 1 pos))
						(aref (nth 1 stre2) pos))
					nil)))))


(defun stre2-from-stre (stre)
	(list 0 stre 0))

(defun stre2-from-string (str)
	(list 1 str 0))

#|(setf a (stre2-from-stre (open "fichier")))
;(setf a (stre2-from-string "fichier"))
(print (get-stre2 a))
(print (get-stre2 a))
(print (get-stre2 a))
(print (get-stre2 a))
(print (get-stre2 a))
(print (get-stre2 a))
(print (get-stre2 a))
(print (get-stre2 a)) |#


(defun go-end-line (stre2); va au bout de la ligne. ensuite: peek ou read renverront #\Newline
	(loop 
		(setf carac (peek-stre2 stre2))
		(if (or (eq carac #\Newline) (eq carac nil))
			(return-from go-end-line))
		(get-stre2 stre2)))

(defun go-end-comment (stre2); va au bout de */ et renvoit si on est encore commenté à la fin
	(let ((car1) (car2 ))
		(loop 
			(setf car1 (get-stre2 stre2))
			(setf car2 (peek-stre2 stre2))
			(when (and (eq car1 #\*) (eq car2 #\/))
				(get-stre2 stre2)
				(return-from go-end-comment nil))
			(if (eq car2 nil)
				(return-from go-end-comment t)))))

(defstruct entry stre2 atab nrenv renv-sl) ;renv-sl: s'il renvoit un slash. C'est con, mais c'est parce que je n'arrive pas à revenir en arrière dans les stream

; rem: tout est fait pour que peek-stre2 marche sans rien faire
(defun nombre-tab (stre2); nombre de tabulations au début de stre2
	(let ((ntab 0) carac)
		(loop 
			(setf carac (peek-stre2 stre2))
		 	(if 
			 	(not (eq carac #\Tab))
			 	(return ntab))
			(get-stre2 stre2)
			(setf ntab (+ 1 ntab))))); alors: ntab vaut le nombre de tab au début de la ligne
		
;(defun nouvelle-ligne (entry)



(defun peek-entry (e)
	(cond 
		((> (entry-nrenv e) 0) #\( )
		((< (entry-nrenv e) 0) #\) )
		(t (peek-stre2 (entry-stre2 e)))))

(defun new-line (e)
	(let ((n (nombre-tab (entry-stre2 e ))))
		(setf (entry-nrenv e) (- n (entry-atab e))) ; nombre de parenthèes à renvoyer
		(setf (entry-atab e) n)))

(defun def-entry (stre2)
	(let ((e (make-entry :stre2 stre2 :atab 0 :nrenv 0  :renv-sl nil)))
		(new-line e)
		e))


(defun get-entry (e)
	(cond 
		((> (entry-nrenv e) 0) (decf (entry-nrenv e))#\( )
		((< (entry-nrenv e) 0) (incf (entry-nrenv e))#\) )
		(t (let ((carac (get-stre2 (entry-stre2 e))))
			(cond 
				((eq carac #\Newline)
				(new-line e)
				#\Newline)
				((and (eq carac nil) (> (entry-atab e) 0)) ; si on se finit par une ligne indentée: on ajoute une ligne ensuite pour qu'elle ne le soit plus
					(new-line e)
					#\Newline)
				(t carac))))))

(defun peek-entry2 (e)
	(if (entry-renv-sl e) 
		#\/
		(peek-entry e)))

(defun test-comm (e) ; vérifit s'il n'y a pas un commentaire
	(let ((res (peek-entry e)) (res2))
		(when (eq res #\/)
			(get-entry e)
			(setf res2 (peek-entry e))
			(cond
				((eq res2 #\/) (go-end-line (entry-stre2 e))); on a vu //
				((eq res2 #\*) (go-end-comment (entry-stre2 e))); on va à la fin du commentaire. On pourra recevoir #\Newline ensuite
				(t (setf (entry-renv-sl e) t))))))

(defun get-entry2 (e); s'occuppe des commentaire: vérifit s'il n'y a pas un // après...
	;(print "a")
	(if (entry-renv-sl e) 
		(progn
			(setf (entry-renv-sl e) nil) 
			#\/)
		(let ((res (get-entry e)))
			(test-comm e) ; en fait il test pour la fois d'après
			res)))


(defun def-entry2 (stre2)
	(let ((e (def-entry stre2)))
		(test-comm e)
		e))

(defun entry2-from-string (st)
	(def-entry2 (stre2-from-string st)))

(defun entry2-from-stre (stre)
	(def-entry2 (stre2-from-stre stre)))

;(setf a (entry-from-stre (open "fichier.c")))
;(setf a (entry-from-string "fghj"))

(defun affiche-stre2 (stre)
	(loop
		;(setf carac (peek-entry2 a))
		(setf carac (get-entry2 stre))
		(if (eq carac nil) (return))
		(print carac)))

(defun affiche-stre2-bis (stre)
	(loop
		(setf carac (peek-entry2 a))
		(get-entry2 stre)
		(if (eq carac nil) (return))
		(print carac)))
;(print (get-stre2 a))
;(affiche-stre2-bis a)

#|(defun get-line (l) ;(first l) vaut 0 si le second argument est un fichier, 1 si c'est une chaine simple. (nth 1 l) vaut la chaine ou le fichier. (nth 2 l) vaut le nombre d'accolades précédentes, et (nth 3 l) vaut t si on était commenté
	(cond 
		((eq (first l) 0)(read-line (nth 1 l) nil))
		((and (eq (first l) 1 ) (> (length (nth 1 l)) 0))
			(let ((res))
				(multiple-value-setq (prem sec) (separe (nth 1 l) #\Newline))
				(setf (nth 1 l) sec)
				prem))
		(t nil)))



(defun contain-string (substr st) ;renvoit la position de substr dans st et -1 s'il n'y est pas
	(let ((la (length substr)) (lb (length st)) (j))
		(dotimes (i (- lb la))
			(setf j 0)
			(loop 
				(if (not (eq (aref st (+ i j)) (aref substr j)))
					(return))
				(setf j (+ 1 j))
				(if (eq j la) 
					(return-from contain-string i))))
		-1))

(defun contain-comment (st) ;renvoit s'il contient /* ou // puis la position
	(let ((lb (length st)))
		(dotimes (i (- lb 2))
			(when (eq (aref st i) #\/)
				(if (eq (aref st (+ 1 i)) #\/)
					(return-from contain-comment (values 0 i)))
				(if (eq (aref st (+ 1 i)) #\*)
					(return-from contain-comment (values 1 i)))))
		(values -1 0)))

(defun get-line-bis (l) ;on va faire en sorte que l'indentation fasse des ( )
	 (let ( ( res (get-line l)) (ntab 0) (a_ntab (nth 2 l)) (car_a_mettre)) ; a_ntab est l'ancien nombre d'accolades
		 (if (null res)
			 (if (> a_ntab 0); c'est pour le cas ou il y resterait des tabulations à la dernière ligne. Il faut renvoyer une dernière ligne avec des )
				 (progn
					 (setf (nth 2 l) 0)
					 (make-string a_ntab :initial-element #\)))
				nil)
			 (progn 
				 (loop 
					 (if 
						 (not (eq (aref res ntab) #\Tab))
						 (return))
					 (setf ntab (+ 1 ntab))); alors: ntab vaut le nombre de tab au début de la ligne
				 (setf (nth 2 l) ntab)
				 (return-from get-line-bis 
						(concatenate 'string 
							(make-string 
								(abs (- ntab a_ntab))
								:initial-element (if (> ntab a_ntab) #\( #\) ))
							(substring res ntab)))))))

(defun uncomment (st c) ; décommente. c vaut t si c'est initialement commenté. renvoit si c'est finalement commenté et la chaine 
	(let ((pos) (kind) (st-res) (c-res))
		(cond 
			((eq c nil)
				(multiple-value-setq (kind pos) (contain-comment st))
				(cond
					((eq kind -1) (values st nil)); il n'y a pas de commentaires
					((eq kind 0) (values (substring st 0 pos) nil)); s'il a repéré //
					((eq kind 1) 
						(multiple-value-setq (st-res c-res) (uncomment (substring st (+ 2 pos)) t))
						(values (concatenate 'string (substring st 0 pos) st-res) c-res))))
			(t
				(setf pos (contain-string "*/" st))
				(if (eq pos -1)
					(values "" t)
					(uncomment 
						(substring st (+ 2 pos))
						nil))))))
					

(defun get-line-tris (l)
	(let ((res (get-line-bis l))(stres)(cres))
		(multiple-value-setq (stres cres) (uncomment res (nth 3 l)))
		(setf (nth 3 l) cres)
		stres))

|#


#|(defun reader-from-file (f)
	(list 0 f 0 nil))

(defun reader-from-string (st)
	(list 1 st 0 nil)) |#

#|(multiple-value-setq (a b) (separe "atfsd" #\a))
(print a)
(print b)|#



;(multiple-value-setq (a b) (uncomment "uf/* dsir*/qfqfd//sfdqs" nil))
;(print a)
;(print b)
